vec< T, M >

see the `vec` page for the full documentation More...

Inheritance diagram for vec< T, M >:

## Public Types

typedef disarray< T, M > | base
typedef T | value_type
typedef base::size_type | size_type
typedef std::ptrdiff_t | difference_type
typedef range | range_type
typedef base::reference | reference
typedef base::const_reference | const_reference
typedef base::iterator | iterator
typedef base::const_iterator | const_iterator
typedef float_traits< value_type >::type | float_type
Public Types inherited from disarray< T, rheo_default_memory_model >
typedef rheo_default_memory_model | memory_type
typedef disarray_rep< T, sequential, std::allocator< T > > | rep
typedef rep::base::size_type | size_type
typedef rep::base::iterator | iterator
typedef rep::base::const_iterator | const_iterator

## Public Member Functions

| vec (const vec< T, M > &)
vec< T, M > & | operator= (const vec< T, M > &x)
| vec (const distributor &ownership, const T &init_val=std::numeric_limits< T >::max())
| vec (const std::initializer_list< details::vec_concat_value< T, M > > &init_list)
vec< T, M > & | operator= (const std::initializer_list< details::vec_concat_value< T, M > > &init_list)
| vec (size_type dis_size=0, const T &init_val=std::numeric_limits< T >::max())
void | resize (const distributor &ownership, const T &init_val=std::numeric_limits< T >::max())
void | resize (size_type size=0, const T &init_val=std::numeric_limits< T >::max())
const_reference | operator[] (size_type i) const
reference | operator[] (size_type i)
T | min () const
T | max () const
T | max_abs () const
int | constraint_process_rank () const
| vec (const vec_range< T, M > &vr)
| vec (const vec_range_const< T, M > &vr)
vec< T, M > & | operator= (const vec_range< T, M > &vr)
vec< T, M > & | operator= (const vec_range_const< T, M > &vr)
vec_range_const< T, M > | operator[] (const range_type &r) const
vec_range< T, M > | operator[] (const range_type &r)
vec< T, M > & | operator= (const int &expr)
vec< T, M > & | operator= (const T &expr)
template<class Expr , class Sfinae = typename std::enable_if< details::is_vec_expr_v2_arg<Expr>::value && ! details::is_vec<Expr>::value >::type>
| vec (const Expr &expr)
template<class Expr , class Sfinae = typename std::enable_if< details::is_vec_expr_v2_arg<Expr>::value && ! details::is_vec<Expr>::value >::type>
vec< T, M > & | operator= (const Expr &expr)

## Detailed Description

### template<class T, class M = rheo_default_memory_model>
class rheolef::vec< T, M >

see the `vec` page for the full documentation

Definition at line 79 of file vec.h.

## Member Typedef Documentation

## base

typedef disarray<T, M> base

Definition at line 84 of file vec.h.

## value_type

typedef T value_type

Definition at line 85 of file vec.h.

## size_type

typedef base::size_type size_type

Definition at line 86 of file vec.h.

## difference_type

typedef std::ptrdiff_t difference_type

Definition at line 87 of file vec.h.

## range_type

typedef range range_type

Definition at line 88 of file vec.h.

## reference

typedef base::reference reference

Definition at line 89 of file vec.h.

## const_reference

typedef base::const_reference const_reference

Definition at line 90 of file vec.h.

## iterator

typedef base::iterator iterator

Definition at line 91 of file vec.h.

## const_iterator

typedef base::const_iterator const_iterator

Definition at line 92 of file vec.h.

## float_type

typedef float_traits<value_type>::type float_type

Definition at line 93 of file vec.h.

## Constructor & Destructor Documentation

## vec() [1/7]

vec | ( | const vec< T, M > & | x | ) |

Definition at line 168 of file vec.h.

## vec() [2/7]

vec | ( | const distributor & | ownership,
|  | const T & | init_val = `std::numeric_limits<T>::max()`
| ) |  |

Definition at line 182 of file vec.h.

## vec() [3/7]

vec | ( | const std::initializer_list< details::vec_concat_value< T, M > > & | init_list | ) |

Definition at line 97 of file vec_concat.h.

## vec() [4/7]

vec | ( | size_type | dis_size = `0`,
|  | const T & | init_val = `std::numeric_limits<T>::max()`
| ) |  |

Definition at line 190 of file vec.h.

## vec() [5/7]

vec | ( | const vec_range< T, M > & | vr | ) |

Definition at line 251 of file vec.h.

## vec() [6/7]

vec | ( | const vec_range_const< T, M > & | vr | ) |

Definition at line 258 of file vec.h.

## vec() [7/7]

vec | ( | const Expr & | expr | ) |

Definition at line 325 of file vec_expr_v2.h.

## Member Function Documentation

## operator=() [1/7]

vec< T, M > & operator= | ( | const vec< T, M > & | x | ) |

Definition at line 175 of file vec.h.

## operator=() [2/7]

vec< T, M > & operator= | ( | const std::initializer_list< details::vec_concat_value< T, M > > & | init_list | ) |

Definition at line 105 of file vec_concat.h.

## resize() [1/2]

void resize | ( | const distributor & | ownership,
|  | const T & | init_val = `std::numeric_limits<T>::max()`
| ) |  |

Definition at line 199 of file vec.h.

## resize() [2/2]

void resize | ( | size_type | size = `0`,
|  | const T & | init_val = `std::numeric_limits<T>::max()`
| ) |  |

Definition at line 208 of file vec.h.

## operator[]() [1/4]

vec< T, M >::const_reference operator[] | ( | size_type | i | ) | const

Definition at line 266 of file vec.h.

## operator[]() [2/4]

vec< T, M >::reference operator[] | ( | size_type | i | ) |

Definition at line 273 of file vec.h.

## min()

T min

Definition at line 293 of file vec.h.

## max()

T max

Definition at line 306 of file vec.h.

## max_abs()

T max_abs

Definition at line 319 of file vec.h.

## constraint_process_rank()

int constraint_process_rank

Definition at line 91 of file vec_concat.h.

## operator=() [3/7]

vec< T, M > & operator= | ( | const vec_range< T, M > & | vr | ) |

Definition at line 244 of file vec.h.

## operator=() [4/7]

vec< T, M > & operator= | ( | const vec_range_const< T, M > & | vr | ) |

Definition at line 234 of file vec.h.

## operator[]() [3/4]

vec_range_const< T, M > operator[] | ( | const range_type & | r | ) | const

Definition at line 287 of file vec.h.

## operator[]() [4/4]

vec_range< T, M > operator[] | ( | const range_type & | r | ) |

Definition at line 280 of file vec.h.

## operator=() [5/7]

vec< T, M > & operator= | ( | const int & | expr | ) |

Definition at line 218 of file vec.h.

## operator=() [6/7]

vec< T, M > & operator= | ( | const T & | expr | ) |

Definition at line 226 of file vec.h.

## operator=() [7/7]

vec< T, M > & operator= | ( | const Expr & | expr | ) |

Definition at line 335 of file vec_expr_v2.h.

The documentation for this class was generated from the following files:

- /build/rheolef-FQTnje/rheolef-7.1/linalg/lib/vec.h
- /build/rheolef-FQTnje/rheolef-7.1/linalg/lib/vec_concat.h
- /build/rheolef-FQTnje/rheolef-7.1/linalg/lib/vec_expr_v2.h